djac_webpep/urls.py
# SPDX-FileCopyrightText: 2022-2024 Helmholtz-Zentrum hereon GmbH
#
# SPDX-License-Identifier: EUPL-1.2

"""URL config
----------

URL patterns of the djac-webpep to be included via::

    from django.urls import include, path

    urlpatters = [
        path(
            "djac-webpep",
            include("djac_webpep.urls"),
        ),
    ]
"""
from __future__ import annotations

from typing import Any

from django.urls import re_path  # noqa: F401

from djac_webpep import app_settings, views  # noqa: F401

#: App name for the djac-webpep to be used in calls to
#: :func:`django.urls.reverse`
app_name = "webpep"

#: urlpattern for the Helmholtz AAI
urlpatterns: list[Any] = [
    re_path(
        r"^(?P<slug>%s)/?$" % app_settings.DJAC_WEBPEP_WEBPEP_TOPIC,
        views.WebPepView.as_view(),
        name="webpep",
    ),
    re_path(
        r"^(?P<slug>%s[-_\w]+)/?$" % app_settings.DJAC_WEBPEP_WEBPEP_TOPIC,
        views.WebPepResponseView.as_view(),
        name="response",
    ),
    re_path(
        r"^(?P<slug>%s)/?$" % app_settings.DJAC_WEBPEP_TOOLS_TOPIC,
        views.BrokerTopicView.as_view(),
        name="clm-tools",
    ),
    re_path(
        r"^(?P<slug>%s)/(?P<function_slug>[\w][-_\w]+)/?$"
        % app_settings.DJAC_WEBPEP_TOOLS_TOPIC,
        views.BrokerTopicFunctionView.as_view(),
        name="clm-tools-function",
    ),
]

testproject/urls.py
# SPDX-FileCopyrightText: 2022-2024 Helmholtz-Zentrum hereon GmbH
#
# SPDX-License-Identifier: CC0-1.0

"""djac-webpep URL Configuration

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/3.2/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  path('', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  path('', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.urls import include, path
    2. Add a URL to urlpatterns:  path('blog/', include('blog.urls'))
"""
from django.conf import settings
from django.contrib import admin
from django.urls import include, path  # noqa: F401

urlpatterns = [
    path("clm-tools/", include("djac_webpep.urls")),
    path("dasf/", include("dasf_broker.urls")),
    path("admin/doc/", include("django.contrib.admindocs.urls")),
    path(settings.ADMIN_LOCATION, admin.site.urls),
    path("accounts/", include("django.contrib.auth.urls")),
    path("", include("academic_community.urls")),
]

djac_webpep/models.py
# SPDX-FileCopyrightText: 2022-2024 Helmholtz-Zentrum hereon GmbH
#
# SPDX-License-Identifier: EUPL-1.2

"""Models
------

Models for the djac-webpep app.
"""


from __future__ import annotations

from django.db import models  # noqa: F401

from djac_webpep import app_settings  # noqa: F401

djac_webpep/forms.py
# SPDX-FileCopyrightText: 2022-2024 Helmholtz-Zentrum hereon GmbH
#
# SPDX-License-Identifier: EUPL-1.2

"""Forms
-----

Forms of the djac-webpep app.
"""

from django import forms
from django_reactive.widget.fields import ReactJSONSchemaFormField
from django_reactive.widget.widgets import ReactJSONSchemaFormWidget

schema = {
    "type": "object",
    "properties": {
        "origin_lon": {
            "title": "Origin Lon",
            "description": "The geographical longitude of the origin (0,0) of the rotated\nsystem.",
            "type": "number",
        },
        "origin_lat": {
            "title": "Origin Lat",
            "description": "The geographical latitude of the origin (0,0) of the rotated\nsystem.",
            "type": "number",
        },
        "dlon": {
            "title": "Dlon",
            "description": "The grid mesh size in degrees in the rotated coordinate system in\nx-direction.",
            "type": "number",
        },
        "dlat": {
            "title": "Dlat",
            "description": "The grid mesh size in degrees in the rotated coordinate system in\ny-direction.",
            "type": "number",
        },
        "nlon": {
            "title": "Nlon",
            "description": "The total number of grid points in X-direction. Maximum number is\n3000.",
            "type": "integer",
        },
        "nlat": {
            "title": "Nlat",
            "description": "The total number of grid points in Y-direction. Maximum number is\n3000.",
            "type": "integer",
        },
        "startlon": {
            "title": "Startlon",
            "description": "The longitude of the lower left corner of the domain in rotated\ncoordinates. The value of STARTLON is counted by starting with zero\nat origin lon.",
            "type": "number",
        },
        "startlat": {
            "title": "Startlat",
            "description": "The latitude of the lower left corner of the domain in rotated\ncoordinates. The value of STARTLAT is counted by starting with zero\nat origin lat.",
            "type": "number",
        },
        "oro": {
            "title": "Oro",
            "description": "The preferred orography data set.\n\n- GLOBE GLOBE orography\n- ASTER ASTER orography. Valid for the region 60S to 60N. Grid\n  width is restricted to <0.05 degrees.",
            "default": "GLOBE",
            "enum": ["GLOBE", "ASTER", "MERIT"],
            "type": "string",
        },
        "landuse": {
            "title": "Landuse",
            "description": "The preferred land use data set.\n\n- GLC2000 land use\n- GLOBCOVER land use\n- ECOCLIMAP land use",
            "default": "GLOBCOVER",
            "enum": ["GLOBCOVER", "GLC2000", "ECOCLIMAP"],
            "type": "string",
        },
        "soil": {
            "title": "Soil",
            "description": "Soil characteristics data set\n\n- FAO-DSMW FAO-DSMW data set\n- HWSD TERRA HWSD data TERRA mapping 1D",
            "default": "FAO-DSMW",
            "enum": ["FAO-DSMW"],
            "type": "string",
        },
        "aot": {
            "title": "Aot",
            "description": "The preferred data set for the aerosol climatology.\n\n- NASA/GISS NASA/GISS data set\n- AeroCom1, MPI_MET AeroCom1, MPI_MET data set",
            "default": "NASA/GISS",
            "enum": ["NASA/GISS", "AeroCom1, MPI_MET"],
            "type": "string",
        },
        "albedo": {
            "title": "Albedo",
            "description": "The preferred data set for use as the solar surface albedo.\n\n- MODIS dry & sat only dry and saturated soil albedo (itype_albedo=2)\n- MODIS12 vis MODIS monthly albedo, visible part (itype_albedo=3) !! only available for versions COSMO-CLM_clm3 and newer !!",
            "default": "MODIS dry & sat",
            "enum": ["MODIS dry & sat", "MODIS12 vis"],
            "type": "string",
        },
        "orofilter": {
            "title": "Orofilter",
            "description": "Enable filtering the orography here or later in INT2LM.\n\n- No:  No Filtering applied (default)\n- Yes: Filtering applied. In this case the pre-settings are as follows:\n\n  ilow_pass_oro=4,\n  numfilt_oro=1,\n  ilow_pass_xso=5,\n  lxso_first=.FALSE.,\n  numfilt_xso=1,\n  rxso_mask=750.0,\n  eps_filter=0.1,\n  rfill_valley=0.0,\n  ifill_valley=1",
            "default": False,
            "type": "boolean",
        },
        "sgsl": {
            "title": "Sgsl",
            "description": "Calculate subgrid-scale parameter S_ORO.\n\n- No: No calculating of S_ORO (default)\n- Yes: S_ORO will be calculated (this option is presently not stable, for certain domains/resolutions etc. it may crash)",
            "default": False,
            "type": "boolean",
        },
        "urban": {
            "title": "Urban",
            "description": "Include surface properties for use in TERRA_URB.\nNote: There is not yet a check for valid lon/lat boundaries!!\n\n- No: No urban parameters. Choose this for polar regions.\n- Yes: fine resolution background data for ISA, valid for mostly\n  Europe 60W-60E, 75N-12N",
            "default": False,
            "type": "boolean",
        },
    },
    "required": [
        "origin_lon",
        "origin_lat",
        "dlon",
        "dlat",
        "nlon",
        "nlat",
        "startlon",
        "startlat",
    ],
}


class WebPepForm(forms.Form):
    """A form for a webpep call."""

    constructor_arguments = ReactJSONSchemaFormField(
        widget=ReactJSONSchemaFormWidget(schema=schema)
    )

djac_webpep/views.py
# SPDX-FileCopyrightText: 2022-2024 Helmholtz-Zentrum hereon GmbH
#
# SPDX-License-Identifier: EUPL-1.2

"""Views
-----

Views of the djac-webpep app to be imported via the url
config (see :mod:`djac_webpep.urls`).
"""

from __future__ import annotations

import base64
import json
import random
import string
from typing import Any, Dict
from uuid import uuid4

from academic_community.utils import PermissionRequiredMixin
from dasf_broker.models import BrokerTopic, ResponseTopic
from django.shortcuts import get_object_or_404
from django.urls import reverse
from django.utils.functional import cached_property
from django.views import generic  # noqa: F401

from djac_webpep import app_settings  # noqa: F401
from djac_webpep import forms  # noqa: F401


def get_random_letters(length: int) -> str:
    return "".join(random.choice(string.ascii_letters) for i in range(length))


class WebPepView(PermissionRequiredMixin, generic.edit.FormView):
    """A view to submit webpep requests via DASF."""

    form_class = forms.WebPepForm

    permission_required = "dasf_broker.can_produce"

    template_name = "webpep/brokertopic_send_form.html"

    @cached_property
    def topic(self) -> BrokerTopic:
        return get_object_or_404(BrokerTopic, slug=self.dasf_topic_slug)

    def get_success_url(self) -> str:
        return reverse("webpep:response", args=(self.response_topic,))

    @cached_property
    def response_topic(self) -> str:
        """A random response topic"""
        topic_name = self.dasf_topic_slug

        return topic_name + "_" + get_random_letters(8)

    @property
    def dasf_topic_slug(self) -> str:
        return self.kwargs["slug"]

    @property
    def permission_object(self):
        return self.topic

    def get_initial(self) -> Dict[str, Any]:
        ret = super().get_initial()
        params = self.request.GET.dict()
        type_map = {
            "orofilter": bool,
            "sgsl": bool,
            "urban": bool,
            "origin_lon": float,
            "origin_lat": float,
            "dlon": float,
            "dlat": float,
            "startlon": float,
            "startlat": float,
            "nlon": int,
            "nlat": int,
        }
        for param, _type in type_map.items():
            if param in params:
                params[param] = _type(params[param])
        ret["constructor_arguments"] = params
        return ret

    def form_valid(self, form):
        data = form.cleaned_data["constructor_arguments"]
        data["class_name"] = "ExtParClient"
        data["function"] = {"func_name": "generate_and_upload_files"}

        payload = base64.b64encode(json.dumps(data).encode("utf-8")).decode(
            "utf-8"
        )

        request = {
            "messageId": str(uuid4()),
            "properties": {
                "response_topic": self.response_topic,
                "requestContext": 1,
                "messageType": "request",
            },
            "payload": payload,
        }

        self.topic.create_and_send_message(self.request.user, request)

        return super().form_valid(form)

    def get_context_data(self, **kwargs: Any) -> Dict[str, Any]:
        return super().get_context_data(
            topic_slug=self.dasf_topic_slug,
            preview_topic=self.response_topic + "_preview",
            container_class="container-fluid mx-4",
            **kwargs,
        )


class WebPepResponseView(PermissionRequiredMixin, generic.DetailView):
    """A view on a response topic."""

    model = ResponseTopic

    permission_required = "dasf_broker.can_consume"

    template_name = "webpep/responsetopic_detail.html"

    def get_permission_object(self):
        return super().get_permission_object().brokertopic_ptr


class BrokerTopicView(PermissionRequiredMixin, generic.DetailView):
    """A view on the available tools."""

    model = BrokerTopic

    permission_required = "dasf_broker.can_produce"

    template_name = "webpep/brokertopic_detail.html"

    def get_context_data(self, **kwargs) -> dict[str, Any]:
        context = super().get_context_data(**kwargs)
        context["topic"] = app_settings.DJAC_WEBPEP_TOOLS_TOPIC
        context["ws_url"] = app_settings.DJAC_WEBPEP_WEBSOCKET_URL_ROUTE
        context["base_breadcrumbs"] = [("CLM Tools", self.request.path)]
        return context


class BrokerTopicFunctionView(BrokerTopicView):
    """A view on a function."""

    def get_context_data(self, **kwargs) -> dict[str, Any]:
        context = super().get_context_data(**kwargs)
        context["func_name"] = self.kwargs["function_slug"]
        return context

djac_webpep/templates/webpep/brokertopic_send_form.html
{% extends "base.html" %}

{% comment %}
SPDX-FileCopyrightText: 2022-2024 Helmholtz-Zentrum hereon GmbH

SPDX-License-Identifier: EUPL-1.2
{% endcomment %}

{% load django_bootstrap5 %}
{% load bootstrap_helpers %}

{% block headline %}
  Create CLM input data
  <button type="button" class="btn btn-round btn-secondary ms-2" data-bs-toggle="modal" data-bs-target="#about-modal">
    <i class="fas fa-question"></i>
  </button>
{% endblock headline %}
{% block title %}WebPEP{% endblock title %}

{% block extrahead %}

{{ block.super }}

<style>
  .form-group {
    margin-top: 2em;
    border-bottom: black 1px solid;
    padding-bottom: 1em;
  }

  button[name="_save"]:disabled + input.btn {
    {% comment %}
      disable preview button when form is invalid (i.e. the _save submit button
      is disabled)
    {% endcomment %}
    pointer-events: none;
    background-color: var(--bs-btn-disabled-bg);
    border-color: var(--bs-btn-disabled-border-color);
    opacity: var(--bs-btn-disabled-opacity);
  }
</style>

{% endblock %}

{% block content %}

  <div class="row">
    {% card header="Input" card_class="mb-4 col-12 col-lg-4 h-100" %}
      <form role="form" method="post">

        {% bootstrap_button "Submit Extpar Job" button_type="submit" name="_save" %}
        <input name="preview" value="Render preview and command" class="btn btn-primary" type="button">

        {% csrf_token %}

        <div class="overflow-scroll mt-4" style="height: 600px;">
          {% bootstrap_form form exclude="constructor_arguments" %}
          <h5>WebPEP parameters</h5>
          <div class="alert alert-secondary">
            Conversion between rotated pole and origin <a href="{% url 'webpep:clm-tools-function' 'clm-tools' 'PolAndOrigin' %}">on this page</a>.
          </div>
          {% bootstrap_field form.constructor_arguments show_label=False %}
        </div>
      </form>
      <div class="alert mt-4 alert-secondary">
        Found a bug? Please open an issue at
        <a href="https://codebase.helmholtz.cloud/hcdc/django/clm-community/djac-webpep/-/issues">
          the <i>djac-webpep</i> source code repository
        </a>.
      </div>
    {% endcard %}


    {% card header="Preview" card_class="col-12 col-lg-8" %}
      {% include "webpep/render_map.html" %}
    {% endcard %}


  {% comment %} {% modal "about-modal" button_text='<i class="fas fa-question"></i>'|safe button_class="btn-round btn-secondary ms-2" %} {% endcomment %}
  {% modal "About WebPEP" "about-modal" %}
    <div class="modal-body">
      <h2>How to use WebPEP</h2>

      <ol>
        <li>Fill in the information on the domain, choose the requested data sets and choose your prefered view mode.</li>

        <li>Click the <i>Preview</i> button to check whether the domain is as you want it to be.</li>
      </ol>
      <p>
        Please report any issues at
        <a href="https://codebase.helmholtz.cloud/hcdc/django/clm-community/djac-webpep/-/issues">
          the source code repository
        </a>.
      </p>

      <h2>Additional Remarks</h2>

      <p>
        WebPEP is a GUI for the EXTPAR program.
      </p>

      <p>
        Please be aware, that the size of the domain of external data has to be
        larger then the size of the actual CCLM domain. At least two further grid
        points at each of the four sides are required. It is recommended to chose the
        domain of the external data set rather large, so that it is possible to
        change the size of the CCLM domain, with shifts of start_lon and start_lat,
        etc. without creating new external data sets.
      </p>

      <p>
        12 monthly albedo can only be used in weather forecast mode, since it is
        not implemented for climate simulations in INT2LM up to now.
      </p>

      <p>
        ASTER orography data are restricted in WebPEP to grid mesh sizes &lt;0.05
        degrees due to the high computational requirements. If you need for good
        reasons data on a coarser grid, please contact the EXTPAR maintainer
        directly.
      </p>

      <p>
        For the deep soil climate temperature a combination of the climatological
        temperature calculated from CRU and ERAInterim 2m temperature is implemented.
        ERAInterim is taken for those regions where CRU does not provide 2m
        temperatures (e.g. Antarctica).
      </p>

      <p>
        Conversion between rotated pole and origin
        <a href="{% url 'webpep:clm-tools-function' 'clm-tools' 'PolAndOrigin' %}">
          on this page
        </a>.
      </p>

      <h2>Version info</h2>
      <ul>
        <li>
          extpar (software to prepare the external parameter data files that are
          used as input for the COSMO and the ICON model):
          <ul>
            <li>Version: <span class='extpar-version'>unknown</span></li>
            <li>Source code (restricted access): <a href="https://github.com/C2SM-RCM/extpar">https://github.com/C2SM-RCM/extpar</a></li>
          </ul>
        </li>
        <li>
          extpar-client (backend module for connecting via DASF):
          <ul>
            <li>Version: <span class='extpar-client-version'>unknown</span></li>
            <li>Source code: <a href="https://codebase.helmholtz.cloud/hcdc/django/clm-community/extpar-client">https://codebase.helmholtz.cloud/hcdc/django/clm-community/extpar-client</a></li>
          </ul>
        </li>
        <li>
          djac-webpep (frontend implementation for this website):
          <ul>
            <li>Source code: <a href="https://codebase.helmholtz.cloud/hcdc/django/clm-community/djac-webpep">https://codebase.helmholtz.cloud/hcdc/django/clm-community/djac-webpep</a></li>
          </ul>
        </li>

      </ul>
    </div>
  {% endmodal %}
  </div>

{% endblock content %}

djac_webpep/templates/webpep/render_map.html
{% comment %}
SPDX-FileCopyrightText: 2022-2024 Helmholtz-Zentrum hereon GmbH

SPDX-License-Identifier: EUPL-1.2
{% endcomment %}

{% load sekizai_tags %}
{% load dasf %}
{% load community_utils %}
{% load bootstrap_helpers %}

<div class="alert alert-danger w-100" role="alert">
    <p>
      The preview function still needs some debugging!
    </p>
  </div>

<div class="max-vh-90 w-100" style="height: 600px;" id="viewDiv"></div>

{% card header="Grid generation command" card_class="mt-4 d-none" card_id="gridGenerationCard" %}
    <pre id="gridGeneration" class="w-100" style="font-size:1.2em; outline:1px solid #AEBDCC; background-color:#F3F5F7; padding:14px;margin:10px; line-height: 120%;">
    </pre>
{% endcard %}

{% addtoblock "css" %}
    <link
      rel="stylesheet"
      href="https://js.arcgis.com/4.25/esri/themes/light/main.css"
    />
{% endaddtoblock %}

{% addtoblock "js" %}
    <script src="https://js.arcgis.com/4.25/"></script>
    <script>
        require(["esri/Map", "esri/views/SceneView", "esri/Graphic", "esri/geometry/SpatialReference"], (
        Map,
        SceneView,
        Graphic,
        SpatialReference
        ) => {
        const map = new Map({
            basemap: "hybrid"
        });

        const view = new SceneView({
            container: "viewDiv",
            map: map,
            zoom: 3
        });

        view.environment.lighting = {
            type: "virtual"
        };

        window.previewView = view;

        function displayPolygon(attrs, rings) {
             /***************************
            * Create a polygon graphic
            ***************************/

            // Create a polygon geometry
            const polygon = {
                type: "polygon", // autocasts as new Polygon()
                rings: rings
            };

            // Create a symbol for rendering the graphic
            const fillSymbol = {
                type: "simple-fill", // autocasts as new SimpleFillSymbol()
                color: [227, 139, 79, 0.5],
                outline: {
                // autocasts as new SimpleLineSymbol()
                color: [255, 255, 255],
                width: 1
                }
            };

            // Add the geometry and symbol to a new graphic
            const polygonGraphic = new Graphic({
                geometry: polygon,
                symbol: fillSymbol,
                attributes: attrs,
                popupTemplate: {
                    title: "Simulation domain",
                    content: [
                        {
                            type: "fields",
                            fieldInfos: [
                                { fieldName: "origin_lon" },
                                { fieldName: "origin_lat" },
                                { fieldName: "pollon" },
                                { fieldName: "pollat" },
                                { fieldName: "polgam" },
                            ]
                        }
                    ]
                }
            });

            // Add the graphics to the view's graphics layer
            view.graphics.removeAll();
            view.graphics.add(polygonGraphic);
            polygonGraphic.layer.when(
                () => { polygonGraphic.layer.goTo(polygonGraphic) }
            );
            const gridElem = document.getElementById("gridGeneration");
            gridElem.innerHTML = `cfu create_rotgrid ${attrs.startlon} ${attrs.startlat} ${attrs.dlon} ${attrs.dlat} ${attrs.nlon} ${attrs.nlat} ${attrs.pollon} ${attrs.pollat} ${attrs.polgam} gridfile`
            document.getElementById("gridGenerationCard").classList.remove("d-none");
        }

        window.displayPolygon = displayPolygon;

        {% if preview_topic %}

            var incomingWebSocket;
            var websocketConnectionAttemps = 0;

            function openIncomingWebSocket() {
            incomingWebSocket = new WebSocket(
                '{% dasf_ws_url preview_topic|str_add:"/session-"|str_add:request.session.session_key %}'
            );

            incomingWebSocket.addEventListener("open", function(e) {
                console.log("Waiting for preview response.");
            })

            incomingWebSocket.addEventListener("message",  function(e) {
                let data = JSON.parse(e.data);

                // acknowledge the message
                incomingWebSocket.send(
                JSON.stringify({"messageId": data.messageId})
                )

                if (data.properties.status === "success") {
                    let payload = JSON.parse(atob(data.payload));
                    if (payload.rings) {
                        displayPolygon(payload.attrs, payload.rings);
                    } else if (payload["extpar-client"]) {
                        console.log("Version info:", payload);
                        $(".extpar-version").html(payload.extpar);
                        $(".extpar-client-version").html(payload["extpar-client"]);
                    }
                } else {
                    let errorMessage = atob(data.payload);
                    displayMessageInToast(`Request failed: <pre>${errorMessage}</pre>`, autohide="false", classes="w-100")
                }
            })

            incomingWebSocket.addEventListener("close", function(event) {
                if (!event.wasClean) {
                websocketConnectionAttemps++;
                if (websocketConnectionAttemps < 5) {
                    console.error(`incomingWebSocket connection died. Reconnecting in 5 seconds... Attempt ${websocketConnectionAttemps} of 5.`);
                    setTimeout(openIncomingWebSocket, 5000);
                } else {
                    console.error("Stop connecting after 5 attempts...");
                    displayMessageInToast(
                    "Lost connection to the incomingWebSocket. Please <button type='button' onclick='window.location.reload()' class='btn btn-link'>reload the page</a>.",
                    autohide="false"
                    );
                }
                }
            })
            }
            openIncomingWebSocket();

            var outgoingWebSocket;
            var websocketConnectionAttemps = 0;

            function openOutgoingWebSocket() {
            outgoingWebSocket = new WebSocket(
                '{% dasf_ws_url topic_slug %}'
            );

            outgoingWebSocket.addEventListener("open", function(e) {
                console.log("Outgoing websocket established.");
                submitPreviewRequest({func_name: "version_info"})
            })

            outgoingWebSocket.addEventListener("close", function(event) {
                if (!event.wasClean) {
                websocketConnectionAttemps++;
                if (websocketConnectionAttemps < 5) {
                    console.error(`outgoingWebSocket connection died. Reconnecting in 5 seconds... Attempt ${websocketConnectionAttemps} of 5.`);
                    setTimeout(openOutgoingWebSocket, 5000);
                } else {
                    console.error("Stop connecting after 5 attempts...");
                    displayMessageInToast(
                    "Lost connection to the outgoingWebSocket. Please <button type='button' onclick='window.location.reload()' class='btn btn-link'>reload the page</a>.",
                    autohide="false"
                    );
                }
                }
            })
            }
            openOutgoingWebSocket();

            function submitPreviewRequest(payload) {
                if (!payload["func_name"]) {
                    payload["class_name"] = "ExtParClient"
                    payload["function"] = {"func_name": "generate_preview_polygon"}
                }
                let request = {
                    properties: {
                        "response_topic": "{{ preview_topic }}",
                        "requestContext": ++contextCounter,
                        "messageType": "request"
                    },
                    payload: btoa(JSON.stringify(payload))
                }
                outgoingWebSocket.send(JSON.stringify(request));
            }

            let contextCounter = 1;

            document.querySelectorAll("input[name=preview]").forEach(
                (elem) => {
                    elem.addEventListener("click", function(event) {
                        let formData = new FormData(event.target.form);
                        let payload = JSON.parse(formData.get("constructor_arguments"));
                        submitPreviewRequest(payload)
                    })
                }
            )

        {% endif %}

        let elem = document.getElementById("extpar-output");
        if (elem) {
            let data = JSON.parse(elem.textContent);

            view.when(() => {
                displayPolygon(data.attrs, data.rings);
            })
        }

    });
    </script>
{% endaddtoblock %}

djac_webpep/templates/webpep/request_finished_mail.html
{% comment %}
SPDX-FileCopyrightText: 2022-2024 Helmholtz-Zentrum hereon GmbH

SPDX-License-Identifier: EUPL-1.2
{% endcomment %}

{% spaceless %}
<p>
  Hello {{ user }}!
</p>
<p>
  Your webpep request has finished. Please access the result at
</p>

<p>
  <a href="{{ root_url }}{% url 'webpep:response' topic.slug %}">{{ root_url }}{% url 'webpep:response' topic.slug %}</a>
</p>

<p>
  Have a nice day,<br>
  Your Community Managers
</p>
{% endspaceless %}